textDatabase = {
	ANT = { outLine = "OUTLINE", fontSize = "15", loc = "TOP", x = 0, y = 0, color = {1, 1, 1, 1}, text = "Search for Satchels (/sfs)", },
	statusText = { outLine = "OUTLINE", fontSize = "16", loc = "LEFT", x = 3, y = 58, color = {0, 1, 0, 1}, text = ""..classVar[4]..":", },
	scanText = { outLine = "OUTLINE", fontSize = "15", loc = "LEFT", x = 99, y = 58, color = {1, 0, 0, 1}, text = ""..runVar[1].."", },
	tankText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 24, y = 37, color = {1, 1, 1, 1}, text = ""..classVar[1]..":", },
	tankScanningText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 58, y = 37, color = {1, 0, 0, 1}, text = ""..runVar[1].."", },
	healerText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 24, y = 5, color = {1, 1, 1, 1}, text = ""..classVar[2]..":", },
	healScanningText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 58, y = 5, color = {1, 0, 0, 1}, text = ""..runVar[1].."", },
	dpsText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 24, y = -28, color = {1, 1, 1, 1}, text = ""..classVar[3]..":", },
	dpsScanningText = { outLine = "OUTLINE", fontSize = "14", loc = "LEFT", x = 58, y = -28, color = {1, 0, 0, 1}, text = ""..runVar[1].."", },
	bagCounter = { outLine = "OUTLINE", fontSize = "14", loc = "TOP", x = 121, y = -30, color = {0, 0.6, 0.8, 1}, bag = true, text = "0", },
	artmaCounter = { outLine = "OUTLINE", fontSize = "14", loc = "TOP", x = 121, y = -54, color = {0, 0.6, 0.8, 1}, bag = true, text = "0", },
	talCounter = { outLine = "OUTLINE", fontSize = "14", loc = "TOP", x = 121, y = -78, color = {0, 0.6, 0.8, 1}, bag = true, text = "0", },
	adeCounter = { outLine = "OUTLINE", fontSize = "14", loc = "TOP", x = 121, y = -102, color = {0, 0.6, 0.8, 1}, bag = true, text = "0", },
};

frameDatabase = {
	scanButton = { zscale = 0, zxscale = 0, yscale = 22/32, xscale = 80/128, texture = true, Type = "Button", width = "80", height = "25", loc = "BOTTOM", x = -80, y = 5, text = "Start", script = true, functionName = "startScanning()", normalTxt = "Interface\\Buttons\\UI-Panel-Button-Up.blp", pushedTxt = "Interface\\Buttons\\UI-Panel-Button-Down.blp", highLightTxt = "Interface\\Buttons\\UI-Panel-Button-Highlight.png", },
	stopButton = { zscale = 0, zxscale = 0, yscale = 22/32, xscale = 80/128, texture = true, Type = "Button", width = "80", height = "25", loc = "BOTTOM", x = 80, y = 5, text = "Stop", script = true, functionName = "stopScanning()", normalTxt = "Interface\\Buttons\\UI-Panel-Button-Up.blp", pushedTxt = "Interface\\Buttons\\UI-Panel-Button-Down.blp", highLightTxt = "Interface\\Buttons\\UI-Panel-Button-Highlight.png", },
	configButton = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, texture = true, Type = "Button", width = "16", height = "16", loc = "TOP", x = 112, y = -5, script = true, functionName = "InterfaceOptionsFrame_OpenToCategory(SearchforSatchels.childpanel)", normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\config.tga", pushedTxt = "Interface\\Addons\\SearchforSatchels\\icons\\configpush.tga", highLightTxt = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp", },
	closeButton = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, texture = true, Type = "Button", width = "16", height = "16", loc = "TOP", x = 130, y = -5, script = true, functionName = "hideMainFrame()", normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\close.tga", pushedTxt = "Interface\\Addons\\SearchforSatchels\\icons\\closepush.tga", highLightTxt = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp", },
	bagIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "20", height = "20", loc = "TOP", x = 97, y = -28, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\bagIcon.tga", },
	artmaIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "20", height = "20", loc = "TOP", x = 97, y = -52, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\artmaIcon.tga", },
	talisIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "20", height = "20", loc = "TOP", x = 97, y = -76, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\talismanIcon.tga", },
	adeIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "20", height = "20", loc = "TOP", x = 97, y = -100, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\adeIcon.tga", },
	tankIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "15", height = "15", loc = "LEFT", x = 6, y = 35, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\tankIcon.tga", },
	healIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "15", height = "15", loc = "LEFT", x = 6, y = 3, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\healerIcon.tga", },
	dpsIcon = { zscale = 0, zxscale = 0, yscale = 1, xscale = 1, Type = "Button", width = "15", height = "15", loc = "LEFT", x = 6, y = -29, normalTxt = "Interface\\Addons\\SearchforSatchels\\icons\\dpsIcon.tga", },
};

-- Variables
local running = false;
local playSound = true;
local raidWarnNotify = true;
local UpdateInterval = 45;
local scanForHeal = true;
local scanForTank = false;
local scanForDps = false;
local addonVersion = "0.1.0";
local satchelFound = false;
local satchelsReceived;
local tokensReceived;
local showUI = false;
local clevel = UnitLevel("Player");
local acetimer = LibStub("AceTimer-3.0")
local instanzaktiv = false;
local shorttext = false;
local soundinifertig = false;
local lootsoundt = false;
local lootsoundb = false;
local ssdataname = "SearchforSatchels";
local jetzt = 0;

function charcheck()
  if (clevel ~= 110) then
    running = false;
    playSound = false;
    raidWarnNotify = false;
    scanForHeal = false;
    showUI = false;
    MainFrame:Hide();
    printsfs(charnotmaxlevel);
  else
    running = false;
    playSound = true;
    raidWarnNotify = true;
    scanForHeal = true;
    showUI = false;
    MainFrame:Hide();
    printsfs(charmaxlevel);
  end
  startScanning();
end

local redColor = {1,0,0,1};
local greenColor = {0,1,0,1};
local yellowColor = {1,1,0,1};

function stopScanning()
	if running then
		satchelFound = false;
		running = false;
		textDatabase.scanText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.scanText.textFrame:SetText(runVar[1]);
		textDatabase.tankScanningText.textFrame:SetText(classScan[1]);
		textDatabase.tankScanningText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.healScanningText.textFrame:SetText(classScan[1]);
		textDatabase.healScanningText.textFrame:SetTextColor(unpack(redColor));
		textDatabase.dpsScanningText.textFrame:SetText(classScan[1]);
		textDatabase.dpsScanningText.textFrame:SetTextColor(unpack(redColor));
	end
end

function startScanning()
  if not running then
		running = true;
		textDatabase.scanText.textFrame:SetTextColor(unpack(greenColor));
		textDatabase.scanText.textFrame:SetText(runVar[2]);
		if scanForTank then
		end
		if scanForHeal then
		end
		if scanForDps then
		end
		RequestLFDPlayerLockInfo();
  end
  beutelsound = 1;
end

function hideMainFrame()
	MainFrame:Hide();
	dbAdd("showMainFrame", false);
end

-- Database values
function dbUpdate()
	dbAdd("updateint", updateIntervalSlider:GetValue());
	dbAdd("version", addonVersion);
	dbAdd("raidwarning", raidWarningButton:GetChecked());
  dbAdd("shorttext", ShorttextButton:GetChecked());
  dbAdd("soundinifertig", InzfertButton:GetChecked());
  dbAdd("lootsoundt", LootSoundTButton:GetChecked());
  dbAdd("lootsoundb", LootSoundBButton:GetChecked());
	dbAdd("sounds", playSoundButton:GetChecked());
	dbAdd("scanTank", scanForTankButton:GetChecked());
	dbAdd("scanHeal", scanForHealButton:GetChecked());
	dbAdd("scanDps", scanForDpsButton:GetChecked());
	dbAdd("satchels", satchelsReceived);
  dbAdd("tokens", tokensReceived);
  dbAdd("talismans", talismansReceived);
  dbAdd("ade", adeReceived);
	dbAdd("showMainFrame", showUI);
	readConfig();
end

function dbanlegen()
  SearchforSatchelsDB = {}
  running = false;
  playSound = true;
  raidWarnNotify = true;
  UpdateInterval = 45;
  scanForHeal = true;
  scanForTank = false;
  scanForDps = false;
  shorttext = false;
  soundinifertig = false;
  lootsoundt = false;
  lootsoundb = false;
  scanForDpsButton:SetChecked(scanForDps);
  scanForTankButton:SetChecked(scanForTank);
  scanForHealButton:SetChecked(scanForHeal);
  playSoundButton:SetChecked(playSound);
  raidWarningButton:SetChecked(raidWarnNotify);
  ShorttextButton:SetChecked(shorttext);
  LootSoundBButton:SetChecked(lootsoundb);
  LootSoundTButton:SetChecked(lootsoundt);
  InzfertButton:SetChecked(soundinifertig);
  
	dbAdd("updateint", 45);
	dbAdd("version", addonVersion);
	dbAdd("raidwarning", "true");
  dbAdd("shorttext", "false");
  dbAdd("lootsoundb", "false");
  dbAdd("lootsoundt", "false");
  dbAdd("soundinifertig", "false");
	dbAdd("sounds", "true");
	dbAdd("scanHeal", "true");
	dbAdd("satchels", 0);
  dbAdd("tokens", 0);
  dbAdd("talismans", 0);
  dbAdd("ade", 0);
	dbAdd("showMainFrame", showUI);
--  printsfs("Datenbank wurde angelegt. config wird neu geladen.");
	readConfig();
end

function readConfig() -- Reads values from DB
	if not SearchforSatchelsDB then
		dbanlegen();
	else
		playSound = SearchforSatchelsDB["sounds"];
		playSoundButton:SetChecked(playSound);
		raidWarnNotify = SearchforSatchelsDB["raidwarning"];
		raidWarningButton:SetChecked(raidWarnNotify);
    shorttext = SearchforSatchelsDB["shorttext"];
    ShorttextButton:SetChecked(shorttext);
    lootsoundb = SearchforSatchelsDB["lootsoundb"];
    LootSoundBButton:SetChecked(lootsoundb);
    lootsoundt = SearchforSatchelsDB["lootsoundt"];
    LootSoundTButton:SetChecked(lootsoundt);
    soundinifertig = SearchforSatchelsDB["soundinifertig"];
    InzfertButton:SetChecked(soundinifertig);
		satchelsReceived = SearchforSatchelsDB["satchels"];
    tokensReceived = SearchforSatchelsDB["tokens"];
    talismansReceived = SearchforSatchelsDB["talismans"];
    adeReceived = SearchforSatchelsDB["ade"];
		UpdateInterval = SearchforSatchelsDB["updateint"];
    if (UpdateInterval == null) then
      UpdateInterval = 45;
    end
    updateIntervalSlider:SetValue(UpdateInterval);
		dbVersion = SearchforSatchelsDB["version"];
		scanForTank = SearchforSatchelsDB["scanTank"];
		scanForHeal = SearchforSatchelsDB["scanHeal"];
		scanForDps = SearchforSatchelsDB["scanDps"];
		scanForDpsButton:SetChecked(scanForDps);
		scanForTankButton:SetChecked(scanForTank);
		scanForHealButton:SetChecked(scanForHeal);
		showUI = SearchforSatchelsDB["showMainFrame"];
    
    if shorttext then
      ssdataname = " lfS ";
    else
      ssdataname = "SearchforSatchels";
    end
    
	end
	if not showUI then
		MainFrame:Hide();
	else
		MainFrame:Show();
	end
end

function dbAdd(var, arg) -- Updates values in db
	SearchforSatchelsDB[var] = arg;
end

function satchelFinder(role, id)
		local eligible, forTank, forHealer, forDamage, itemCount, money, xp = GetLFGRoleShortageRewards(id, 1)
		if (itemCount ~= 0 or money ~= 0 or xp ~= 0) then
			if forTank and scanForTank and role == "tank" then
				return true;
			end
			if forHealer and scanForHeal and role == "heal" then
				return true;
			end
			if forDamage and scanForDps and role == "dps" then
				return true;
			end
		end
end

local function Teleport()
	if IsInInstance() then
		_G.LFGTeleport(true)
	else
		_G.LFGTeleport(false)
	end
end

function SatchelScan(self, event, arg, arg2)
	if event == "ADDON_LOADED" and arg == "SearchforSatchels" then
		readConfig();
		if SearchforSatchelsDB["satchels"] == null then
			dbAdd("satchels", 0);
			textDatabase.bagCounter.textFrame:SetText(satchelsReceived);
		else
			textDatabase.bagCounter.textFrame:SetText(satchelsReceived);
		end
		if SearchforSatchelsDB["tokens"] == null then
			dbAdd("tokens", 0);
			textDatabase.artmaCounter.textFrame:SetText(tokensReceived);
		else
			textDatabase.artmaCounter.textFrame:SetText(tokensReceived);
		end
		if SearchforSatchelsDB["talismans"] == null then
			dbAdd("talismans", 0);
			textDatabase.talCounter.textFrame:SetText(talismansReceived);
		else
			textDatabase.talCounter.textFrame:SetText(talismansReceived);
		end
		if SearchforSatchelsDB["ade"] == null then
			dbAdd("ade", 0);
			textDatabase.adeCounter.textFrame:SetText(adeReceived);
		else
			textDatabase.adeCounter.textFrame:SetText(adeReceived);
		end
	end
 
	if event == "CHAT_MSG_LOOT" and string.find(arg, ibeutel) and not (MailFrame:IsShown() or TradeFrame:IsShown()) then
    if string.find(arg, msgloot) or string.find(arg, lootmsg) then
		  satchelsReceived = satchelsReceived + 1;
		  dbAdd("satchels", satchelsReceived);
		  textDatabase.bagCounter.textFrame:SetText(satchelsReceived);
      printsfs(""..inicomplete.."");
      if lootsoundb then
        PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\loot.mp3", "Master");
      end
      running = false;
      instanzaktiv = false;
      readConfigTimer = acetimer:ScheduleTimer(function()
        readConfig();
      end, 3.5)
      invitationAlertTimer = acetimer:ScheduleTimer(function()
        startScanning();
        MainFrame:Show();
      end, 5)
      if soundinifertig then
        acetimer:CancelTimer(inifertigTimer, true);
        inifertigTimer = acetimer:ScheduleTimer(function()
          PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\inifertig.mp3", "Master");
        end, 2.5)
      end
    end
	end
	if event == "CHAT_MSG_LOOT" and string.find(arg, juwel) and not (MailFrame:IsShown() or TradeFrame:IsShown()) then
    if string.find(arg, msgloot) or string.find(arg, lootmsg) then
		  tokensReceived = tokensReceived + 1;
		  dbAdd("tokens", tokensReceived);
		  textDatabase.artmaCounter.textFrame:SetText(tokensReceived);
      printsfs(""..loottexta.." "..juwel.." "..loottextb.."");
      if lootsoundt then
        PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\coin.mp3", "Master");
      end
    end
	end
	if event == "CHAT_MSG_LOOT" and string.find(arg, talisman) and not (MailFrame:IsShown() or TradeFrame:IsShown()) then
    if string.find(arg, msgloot) or string.find(arg, lootmsg) then
		  talismansReceived = talismansReceived + 1;
		  dbAdd("talismans", talismansReceived);
		  textDatabase.talCounter.textFrame:SetText(talismansReceived);
      printsfs(""..loottexta.." "..talisman.." "..loottextb.."");
      if lootsoundt then
        PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\coin.mp3", "Master");
      end
    end
	end
	if event == "CHAT_MSG_LOOT" and string.find(arg, aderfolge) and not (MailFrame:IsShown() or TradeFrame:IsShown()) then
    if string.find(arg, msgloot) or string.find(arg, lootmsg) then
		  adeReceived = adeReceived + 1;
		  dbAdd("ade", adeReceived);
		  textDatabase.adeCounter.textFrame:SetText(adeReceived);
      printsfs(""..loottexta..""..loottextc.." "..aderfolge.." "..loottextb.."");
      if lootsoundt then
        PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\coin.mp3", "Master");
      end
    end
	end
  if event == "LFG_PROPOSAL_SHOW" then
    printsfs(""..inimsg.."");
    invitationAlertTimer = acetimer:ScheduleTimer(function()
      if playSound then
        PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\alert.mp3", "Master");
      end
      instanzaktiv = true;
    end, 8)
  end
  if event == "LFG_COMPLETION_REWARD" then
    running = false;
    instanzaktiv = false;
    stopScanning();
    readConfigTimer = acetimer:ScheduleTimer(function()
      readConfig();
    end, 3.5)
    invitationAlertTimer = acetimer:ScheduleTimer(function()
      startScanning();
      MainFrame:Show();
    end, 5)
    if soundinifertig then
      acetimer:CancelTimer(inifertigTimer, true);
      inifertigTimer = acetimer:ScheduleTimer(function()
        PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\inifertig.mp3", "Master");
      end, 2.5)
    end
  end
  if event == "LFG_PROPOSAL_UPDATE" then
    local proposalExists, id, typeID, subtypeID, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader = GetLFGProposal();
    stopScanning();
		if hasResponded then
			acetimer:CancelTimer(invitationAlertTimer, true);
		end
  end
  if event == "LFG_PROPOSAL_FAILED" then
    startScanning();
    acetimer:CancelTimer(invitationAlertTimer, true);
  end
	if running then		
		if event == "LFG_UPDATE_RANDOM_INFO" then
			-- Tank Scanner
			if scanForTank then
				if satchelFinder("tank", 1046) then
					satchelFound = true;
					textDatabase.tankScanningText.textFrame:SetText(classScan[3]);
					textDatabase.tankScanningText.textFrame:SetTextColor(unpack(greenColor));
          jtime = jetzt + UpdateInterval;
          if time() > jtime then
            jetzt = time();
            jtime = jetzt + UpdateInterval;
            acetimer:CancelTimer(msgAlertTimerTank, true);
            msgAlertTimerTank = acetimer:ScheduleTimer(function()
              printsfs(ctaVar[1]);
	 				    if raidWarnNotify then
					  	  RaidNotice_AddMessage(RaidWarningFrame, ctaVar[1], ChatTypeInfo["RAID_WARNING"])
					    end
					    if not MainFrame:IsShown() then
					  	  MainFrame:Show();
					    end
            end, 0.5)
          end
				else
					textDatabase.tankScanningText.textFrame:SetText(classScan[2]);
					textDatabase.tankScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
			end
			-- Healer Scanner
			if scanForHeal then
				if satchelFinder("heal", 1046) then
					satchelFound = true;
					textDatabase.healScanningText.textFrame:SetText(classScan[3]);
					textDatabase.healScanningText.textFrame:SetTextColor(unpack(greenColor));
          jtime = jetzt + UpdateInterval;
          if time() > jtime then
            jetzt = time();
            jtime = jetzt + UpdateInterval;
            acetimer:CancelTimer(msgAlertTimerHeal, true);
            msgAlertTimerHeal = acetimer:ScheduleTimer(function()
              printsfs(ctaVar[2]);
	 				    if raidWarnNotify then
					  	  RaidNotice_AddMessage(RaidWarningFrame, ctaVar[2], ChatTypeInfo["RAID_WARNING"])
					    end
					    if not MainFrame:IsShown() then
					  	  MainFrame:Show();
					    end
            end, 0.5)
          end
				else
					textDatabase.healScanningText.textFrame:SetText(classScan[2]);
					textDatabase.healScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
			end
			-- Dps Scanner
			if scanForDps then
				if satchelFinder("dps", 1046) then
					satchelFound = true;
					textDatabase.dpsScanningText.textFrame:SetText(classScan[3]);
					textDatabase.dpsScanningText.textFrame:SetTextColor(unpack(greenColor));
          jtime = jetzt + UpdateInterval;
          if time() > jtime then
            jetzt = time();
            jtime = jetzt + UpdateInterval;
            acetimer:CancelTimer(msgAlertTimerDPS, true);
            msgAlertTimerDPS = acetimer:ScheduleTimer(function()
              printsfs(ctaVar[3]);
	 				    if raidWarnNotify then
					  	  RaidNotice_AddMessage(RaidWarningFrame, ctaVar[3], ChatTypeInfo["RAID_WARNING"])
					    end
					    if not MainFrame:IsShown() then
					  	  MainFrame:Show();
					    end
            end, 0.5)
          end
				else
					textDatabase.dpsScanningText.textFrame:SetText(classScan[2]);
					textDatabase.dpsScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
			end
			if scanForDps or scanForTank or scanForHeal then
				if not satchelFinder("tank", 1046) and not satchelFinder("heal", 1046) and not satchelFinder("dps", 1046) then
					satchelFound = false;
				end
			end
		end
	end
end

function uiConfig() -- Draws Config Panel --
	SearchforSatchels = {};
	SearchforSatchels.panel = CreateFrame("Frame", "SearchforSatchelsInfo", UIParent );
	SearchforSatchels.panel.name = "Search for Satchels";
	InterfaceOptions_AddCategory(SearchforSatchels.panel);

	SearchforSatchels.childpanel = CreateFrame("Frame", "SearchforSatchelsConfig", SearchforSatchels.panel);
	SearchforSatchels.childpanel.name = "Options";
	SearchforSatchels.childpanel.parent = SearchforSatchels.panel.name;
	InterfaceOptions_AddCategory(SearchforSatchels.childpanel);
	SearchforSatchels.panel.okay = function(self) dbUpdate(); end;
	
 	configurationText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	configurationText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 18, "OUTLINE");
	configurationText:SetPoint("TOP", 0, -7);
	configurationText:SetText("Search for Satchels v"..addonVersion.." Configuration!");
	-- Scanner Options
	scanOptionText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	scanOptionText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 16, "OUTLINE");
	scanOptionText:SetPoint("TOPLEFT", 10, -16);
	scanOptionText:SetText("|cffff0000"..cfgsopt.."|r");
	-- Tank CheckBox
	scanForTankButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	scanForTankButton:SetPoint("TOPLEFT", 8, -32);
 	scanForTankText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	scanForTankText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	scanForTankText:SetPoint("TOPLEFT", 30, -36);
	scanForTankText:SetText(cfgsft);
	-- Healer CheckBox
	scanForHealButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	scanForHealButton:SetPoint("TOPLEFT", 8, -52);
 	scanForHealText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	scanForHealText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	scanForHealText:SetPoint("TOPLEFT", 30, -56);
	scanForHealText:SetText(cfgsfh);
	-- Dps CheckBox
 	scanForDpsButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	scanForDpsButton:SetPoint("TOPLEFT", 8, -72);
 	scanForDpsText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	scanForDpsText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	scanForDpsText:SetPoint("TOPLEFT", 30, -76);
	scanForDpsText:SetText(cfgsfd);
	-- Notifications
	scanOptionText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	scanOptionText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 16, "OUTLINE");
	scanOptionText:SetPoint("TOPLEFT", 10, -102);
	scanOptionText:SetText("|cffff0000"..cfgbopt.."|r");
	-- Sound CheckBox
	playSoundButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	playSoundButton:SetPoint("TOPLEFT", 8, -118);
 	playSoundText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	playSoundText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	playSoundText:SetPoint("TOPLEFT", 30, -122);
	playSoundText:SetText(cfgsiei);
	-- Raidwarning CheckBox
	raidWarningButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	raidWarningButton:SetPoint("TOPLEFT", 8, -138);
 	raidWarningText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	raidWarningText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	raidWarningText:SetPoint("TOPLEFT", 30, -142);
	raidWarningText:SetText(cfgsrw);
	-- Shorttext CheckBox
	ShorttextButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	ShorttextButton:SetPoint("TOPLEFT", 8, -158);
 	ShorttextText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	ShorttextText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	ShorttextText:SetPoint("TOPLEFT", 30, -162);
	ShorttextText:SetText(cfgdbkt);
	-- LootSound (Token) CheckBox
	LootSoundTButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	LootSoundTButton:SetPoint("TOPLEFT", 8, -178);
 	LootSoundTText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	LootSoundTText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	LootSoundTText:SetPoint("TOPLEFT", 30, -182);
	LootSoundTText:SetText(cfgsto);
	-- LootSound (Zusatz-Beutel) CheckBox
	LootSoundBButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	LootSoundBButton:SetPoint("TOPLEFT", 8, -198);
 	LootSoundBText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	LootSoundBText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	LootSoundBText:SetPoint("TOPLEFT", 30, -202);
	LootSoundBText:SetText(cfgbeu);
	-- InstanzfertigSound CheckBox
	InzfertButton = CreateFrame("CheckButton", nil, SearchforSatchels.childpanel, "ChatConfigCheckButtonTemplate");
	InzfertButton:SetPoint("TOPLEFT", 8, -218);
 	InzfertText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	InzfertText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	InzfertText:SetPoint("TOPLEFT", 30, -222);
	InzfertText:SetText(cfgsini);
	-- Slider for Scanner Interval
	sliderText = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	sliderText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 16, "OUTLINE");
	sliderText:SetPoint("TOPLEFT", 145, -265);
	sliderText2 = SearchforSatchels.childpanel:CreateFontString(nil, "OVERLAY")
	sliderText2:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "OUTLINE");
	sliderText2:SetPoint("TOPLEFT", 10, -248);
	sliderText2:SetText(cfgupdateint);
	updateIntervalSlider = CreateFrame("Slider", nil, SearchforSatchels.childpanel, "OptionsSliderTemplate")
	updateIntervalSlider:SetScript("OnValueChanged", function(self) sliderText:SetText(updateIntervalSlider:GetValue()); end)
	updateIntervalSlider:SetPoint("TOPLEFT", 10, -263);
	updateIntervalSlider:SetWidth(130);
	updateIntervalSlider:SetHeight(20);
	updateIntervalSlider:SetOrientation('HORIZONTAL');
	updateIntervalSlider:SetMinMaxValues(1, 90);
	updateIntervalSlider:SetValueStep(1);
	updateIntervalSlider:Show();
end

function drawFrames()
	uiConfig();
	MainFrame = CreateFrame("Frame", "DragFrame2", UIParent)
	MainFrame:SetMovable(true)
	MainFrame:EnableMouse(true)
	MainFrame:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving();
			self.isMoving = true;
		end
	end)
	MainFrame:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetScript("OnHide", function(self)
		if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetWidth(280);
	MainFrame:SetHeight(165);
	MainFrame:SetPoint("BOTTOMLEFT", 800, 400);
	MainFrame:SetFrameStrata("BACKGROUND")
	MainFrame:SetBackdrop({ 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Addons\\SearchforSatchels\\border\\border.tga", tile = false, tileSize = 0, edgeSize = 8, 
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	});
	for i, frameData in pairs(frameDatabase) do
		frameData.frame = CreateFrame(frameData.Type,nil,MainFrame, UIPanelButtonTemplate);
		frameData.frame:SetWidth(frameData.width);
		frameData.frame:SetHeight(frameData.height);
		frameData.frame:SetPoint(frameData.loc, frameData.x, frameData.y);
		frameData.frame:SetNormalTexture(frameData.normalTxt);
		frameData.frame:SetPushedTexture(frameData.pushedTxt);
		frameData.frame:SetHighlightTexture(frameData.highLightTxt);
		frameData.frame:GetNormalTexture():SetTexCoord(frameData.zxscale,frameData.xscale,frameData.zscale,frameData.yscale);
		if frameData.texture then
			frameData.frame:GetPushedTexture():SetTexCoord(frameData.zxscale,frameData.xscale,frameData.zscale,frameData.yscale);
			frameData.frame:GetHighlightTexture():SetTexCoord(frameData.zxscale,frameData.xscale,frameData.zscale,frameData.yscale);
		end
		if frameData.text then
			local buttonText = frameData.frame:CreateFontString(nil, "OVERLAY")
			buttonText:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", 14, "");
			buttonText:SetPoint("CENTER", 0, 0);
			buttonText:SetTextColor(unpack(yellowColor));
			buttonText:SetText(frameData.text);
		end
		if frameData.script then
			frameData.frame:SetScript("OnClick", loadstring(frameData.functionName));
		end
	end
end

function drawText() -- Draws the Text -- 
	for i, controlData in pairs(textDatabase) do
		controlData.textFrame = MainFrame:CreateFontString(nil, "OVERLAY")
		controlData.textFrame:SetFont("Interface\\Addons\\SearchforSatchels\\fonts\\font.TTF", controlData.fontSize, controlData.outLine);
		controlData.textFrame:SetPoint(controlData.loc, controlData.x, controlData.y);
		controlData.textFrame:SetTextColor(unpack(controlData.color));
		controlData.textFrame:SetText(controlData.text);
	end
end

-- On Load
function SearchforSatchels_OnLoad(self)
	printsfs("Search for Satchels v"..addonVersion.." "..aloaded.."!");
	printsfs("->> "..loadmsgd.."");
	self:RegisterEvent("LFG_OFFER_CONTINUE");
	self:RegisterEvent("LFG_ROLE_CHECK_ROLE_CHOSEN");
	self:RegisterEvent("LFG_QUEUE_STATUS_UPDATE");
	self:RegisterEvent("LFG_BOOT_PROPOSAL_UPDATE");
	self:RegisterEvent("LFG_UPDATE");
	self:RegisterEvent("LFG_ROLE_CHECK_SHOW");
	self:RegisterEvent("LFG_ROLE_CHECK_HIDE");
	self:RegisterEvent("LFG_ROLE_UPDATE");
  
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO");
	self:RegisterEvent("CHAT_MSG_LOOT");
	self:RegisterEvent("LFG_PROPOSAL_SHOW");
	self:RegisterEvent("LFG_PROPOSAL_SUCCEEDED");
  self:RegisterEvent("PLAYER_ENTERING_WORLD");
  self:RegisterEvent("LFG_PROPOSAL_UPDATE");
  self:RegisterEvent("LFG_PROPOSAL_FAILED");
	self:RegisterEvent("LFG_COMPLETION_REWARD");
  
	self:SetScript("OnEvent", SatchelScan)
	drawFrames();
	drawText();
	SLASH_SearchforSatchels1, SLASH_SearchforSatchels2 = "/searchforsatchels", "/sfs"
	SlashCmdList.SearchforSatchels = function(msg)
		if msg == "open" then
			if MainFrame:IsShown() then
				MainFrame:Hide();
				showUI = false;
			else
				MainFrame:Show();
				showUI = true;
			end
			dbUpdate();
		elseif msg == "reset" then
		  satchelsReceived = 0;
		  dbAdd("satchels", satchelsReceived);
      textDatabase.bagCounter.textFrame:SetText(satchelsReceived);
		  tokensReceived = 0;
		  dbAdd("tokens", tokensReceived);
      textDatabase.artmaCounter.textFrame:SetText(tokensReceived);
		  talismansReceived = 0;
		  dbAdd("talismans", talismansReceived);
      textDatabase.talCounter.textFrame:SetText(talismansReceived);
      
		  adeReceived = 0;
		  dbAdd("ade", adeReceived);
      textDatabase.adeCounter.textFrame:SetText(adeReceived);
      
			printsfs(resetmsg);
		elseif msg == "config" then
			InterfaceOptionsFrame_OpenToCategory(SearchforSatchels.childpanel);
		else
			printsfs("========= Search for Satchels v"..addonVersion.." =========");
			printsfs("->> "..loadmsga.."");
			printsfs("->> "..loadmsgb.."");
			printsfs("->> "..loadmsgc.."");
		end
		msg = ""
	end
  charcheck();    
end

function printsfs(msg)
	print("|cFFFF007F"..msg .."|r");
end

function SearchforSatchels_OnUpdate(self, elapsed)
	if running then
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
    while (self.TimeSinceLastUpdate > beutelsound) do
			RequestLFDPlayerLockInfo();
			if satchelFound and playSound and running then
				PlaySoundFile("Interface\\AddOns\\SearchforSatchels\\sound\\fatality.ogg", "Master");
        beutelsound = 999999;
			end
      self.TimeSinceLastUpdate = 0;
		end
	end
end

local db;
local defaults = {
	profile = {
    SearchforSatchelsIconStorage = {},
	},
};

local SearchforSatchelsObject = {
	type = "launcher",
	icon = "Interface\\Addons\\SearchforSatchels\\icons\\bagIcon.tga",
	label = "SearchforSatchels",
	OnClick = function(self, button)
    if button == "LeftButton" then
      if MainFrame:IsShown() then
        MainFrame:Hide();
        showUI = false;
      else
        MainFrame:Show();
        showUI = true;
      end
    elseif button == "RightButton" then
      InterfaceOptionsFrame_OpenToCategory(SearchforSatchels.childpanel);
      InterfaceOptionsFrame_OpenToCategory(SearchforSatchels.childpanel);
	  elseif button == "MiddleButton" then
		  Teleport()
    end
	end,
	OnTooltipShow = function(tooltip)
		tooltip:AddLine("Search for Satchels v"..addonVersion.."");
    tooltip:AddLine(lclick);
    tooltip:AddLine(rclick);
    tooltip:AddLine(mclick);
	end,
};

function updateDB(self, event, database)
	db = database.profile;
  LibStub("LibDBIcon-1.0"):Refresh("SearchforSatchelsButton", db.SearchforSatchelsIconStorage);
end

local vars = LibStub("AceDB-3.0"):New("AddonSavedVarStorage", defaults);
vars:RegisterCallback("OnProfileChanged", updateDB);
vars:RegisterCallback("OnProfileCopied", updateDB);
vars:RegisterCallback("OnProfileReset", updateDB);
db = vars.profile;

LibStub("LibDBIcon-1.0"):Register("SearchforSatchelsButton", SearchforSatchelsObject, db.SearchforSatchelsIconStorage);

local function GetScreenHalf()
	local _, y = GetCursorPosition()
	if y * 2 > UIParent:GetHeight() then
		return "TOP"
	else
		return "BOTTOM"
	end
end

databrokernametimer = acetimer:ScheduleTimer(function()
  readConfig()                     
  SearchforSatchelsDataBroker = LibStub("LibDataBroker-1.1"):NewDataObject(ssdataname, {
  	type = "launcher",
  	icon = "Interface\\Addons\\SearchforSatchels\\icons\\bagIcon.tga",
  	label = "SearchforSatchels",
  	OnEnter = function(self)
      bagicon = "|TInterface\\Addons\\SearchforSatchels\\icons\\bagIcon.tga:0|t";
      tokenicon = "|TInterface\\Addons\\SearchforSatchels\\icons\\artmaIcon.tga:0|t";
      talismanicon = "|TInterface\\Addons\\SearchforSatchels\\icons\\talismanIcon.tga:0|t";
      adeicon = "|TInterface\\Addons\\SearchforSatchels\\icons\\adeIcon.tga:0|t";
  		GameTooltip:SetOwner(self, GetScreenHalf() == "TOP" and "ANCHOR_BOTTOM" or "ANCHOR_TOP")
  		GameTooltip:SetText("\r\nSearchforSatchels v"..addonVersion.."");
      GameTooltip:AddDoubleLine(""..bagicon.." "..ibeutel..":", satchelsReceived);
      GameTooltip:AddDoubleLine(""..tokenicon.." "..juwel..":", tokensReceived);
      GameTooltip:AddDoubleLine(""..talismanicon.." "..talisman..":", talismansReceived);
      GameTooltip:AddDoubleLine(""..adeicon.." "..aderfolge..":", adeReceived);
      GameTooltip:AddLine("\r\n"..lclick.."");
      GameTooltip:AddLine(rclick);
      GameTooltip:AddLine(mclick);
  		GameTooltip:Show()
  	end,
  	OnClick = function(self, button)
      if button == "LeftButton" then
        if MainFrame:IsShown() then
          MainFrame:Hide();
          showUI = false;
        else
          MainFrame:Show();
          showUI = true;
        end
      elseif button == "RightButton" then
        InterfaceOptionsFrame_OpenToCategory(SearchforSatchels.childpanel);
        InterfaceOptionsFrame_OpenToCategory(SearchforSatchels.childpanel);
  	  elseif button == "MiddleButton" then
  		  Teleport()
      end
  	end,
  })
end, 3)